/*
 *ΰDirichlet 
 *
 */

#include<stdio.h>
#include<math.h>
#include<matrix.h>
#define G_DOUBLE
#include <glsc.h>
#define PI M_PI

main()
{
  int i,j,k,Kmax,NR,NT,skip;
  double tau,hr,ht,lambdar,lambdat,lambdar2,lambdat2,Tmax,t,ri,dt;
  matrix u1,u2,u3;
  double f(),g(), maxnorm(), norm;

  printf("NR=\n");  
  scanf("%d",&NR);
  printf("NTHETA=\n");  
  scanf("%d",&NT);

  printf("tau=\n");  scanf("%lf",&tau);

  u1=new_matrix(NR+1,NT+1);
  u2=new_matrix(NR+1,NT+1);
  u3=new_matrix(NR+1,NT+1);

  hr=1.0/NR;
  ht=2.0*PI/NT;
  printf("hr=%f\n",hr);
  printf("htheta=%f\n",ht);
  
  lambdar=tau/hr;
  lambdat=tau/ht;
  printf("lambdar=%f\n",lambdar);
  printf("lambdatheta=%f\n",lambdat);
  printf("lambdar^2=%f\n",lambdar*lambdar);
  printf("lambdatheta^2=%f\n",lambdat*lambdat);
  lambdar2=lambdar*lambdar;
  lambdat2=lambdat*lambdat;
  printf("lambdar^2+NR^2*lambdatheta^2=%f\n",lambdar2+NR*NR*lambdat2);

  printf("Tmax=\n");
  scanf("%lf",&Tmax);
  printf("t="); scanf("%lf", &dt);
  skip=dt/tau+0.5;

  g_init("Meta10",250.0,160.0);
  g_device(G_BOTH);
  g_def_scale(0,0.0,1.0,0.0,1.0,30.0,70.0,100.0,72.0);
  g_def_scale(4,-1.0,1.0,-1.0,1.0,30.0,30.0,100.0,100.0);
  g_def_line(0,G_BLACK,0,G_LINE_SOLID);
  g_sel_scale(0);

  Kmax=(Tmax+0.1*tau)/tau;     

  for(i=1;i<=NR-1;i++){
    for(j=0;j<=NT-1;j++){
      u1[i][j]=f(i*hr,j*ht);
    }
  }
  {
    double mean;
    mean=0;
    for(j=0;j<NT;j++)
      mean+=u1[1][j];
    mean/=NT;
    for(j=0;j<NT;j++)
      u1[0][j]=mean;
  }
  for(i=0;i<=NR;i++){ 
   u1[i][NT]=u1[i][0];
  }
  for(j=0;j<=NT-1;j++){
    u1[NR][j]=0.0;
  }

  g_cls();
  g_hidden2(1.0,1.0,0.4,-1.0,1.0,5.0,25.0,20.0,20.0,20.0,
            150.0,100.0,u1,NR+1,NT+1,
            1,G_SIDE_NONE,2,1);

  for(i=1;i<=NR-1;i++) {
    ri=i*hr;
    for(j=0;j<=NT-1;j++) {
      int jp1,jm1;
      jp1=j+1;if(jp1==NT)jp1=0;
      jm1=j-1;if(jm1==-1)jm1=NT-1;
      u2[i][j]=(1.0-lambdar2-(lambdat2/(ri*ri)))*u1[i][j]
                +0.5*(lambdar2*(u1[i-1][j]+u1[i+1][j])
                 +((tau*tau)/(2.0*ri*hr))*(u1[i+1][j]-u1[i-1][j])
                  +(lambdat2/(ri*ri))*(u1[i][jm1]+u1[i][jp1]))
                   +tau*g(i*hr,j*ht);    
    }
  }
  {
    double mean;
    mean=0;
    for(j=0;j<NT;j++)
      mean+=u2[1][j];
    mean/=NT;
    for(j=0;j<NT;j++)
      u2[0][j]=mean;
  }
  for(i=0;i<=NR;i++){
    u2[i][NT]=u2[i][0];
  }  
  for(j=0;j<=NT-1;j++){
    u2[NR][j]=0.0;
  }
    
  for(k=1;k<=Kmax;k++){
    for(i=1;i<=NR-1;i++) {
      ri=i*hr;
      for(j=0;j<=NT-1;j++) {
        int jp1,jm1;
        jp1=j+1; if(jp1 == NT)jp1=0; 
        jm1=j-1; if(jm1 == -1)jm1=NT-1; 
        u3[i][j]=2.0*(1.0-lambdar2-(lambdat2/(ri*ri)))*u2[i][j]
                  +lambdar2*(u2[i+1][j]+u2[i-1][j])
                   +((tau*tau)/(2.0*ri*hr))*(u2[i+1][j]-u2[i-1][j])
                    +(lambdat2/(ri*ri))*(u2[i][jp1]+u2[i][jm1])-u1[i][j];
      }
    }
    /* */
    for (i = 0; i < NR; i++)
      printf("%f\n", u3[i][0]);
    /* r=0 */
    {
      double mean;
      mean=0;
      for(j=0;j<NT;j++)
        mean += u3[1][j];
      mean /= NT;
      for(j=0;j<NT;j++)
        u3[0][j]=mean;
    }

    /* Dirichlet (r=1) */
    for(j=0;j<=NT-1;j++){  
      u3[NR][j]=0.0;
    }
    /* =2ФΤȤϦ=0ΤȤΥԡ */
    for(i=0;i<=NR;i++){
      u3[i][NT]=u3[i][0];
    }

    for(i=0;i<=NR;i++){
      for(j=0;j<=NT;j++){
        u1[i][j]=u2[i][j];
        u2[i][j]=u3[i][j];
      }
    }

    norm = maxnorm(u3, NR, NT);
    printf("norm=%e=%f\n", norm, norm);
    if (norm > 10.0)
      break;

    if (k%skip==0) {
      g_cls();
      g_hidden2(1.0,1.0,0.4,-1.0,1.0,5.0,25.0,20.0,20.0,20.0,
                150.0,100.0,u2,NR+1,NT+1,
                1,G_SIDE_NONE,2,1);
      msleep(1000);
    }
    t=tau*k;
  }

    g_sleep(-1.0);
    g_term();
    return 0;
}

double maxnorm(u, m, n)
matrix u;
int m, n;
{
  int i, j, maxi, maxj;
  double max, abs;
  max = 0.0;
  for (i = 0; i <= m; i++)
    for (j = 0; j <= n; j++) {
      abs = fabs(u[i][j]);
      if (abs > max) {
        max = abs;
        maxi = i;
        maxj = j;
      }
    }
  printf("maxi=%d, maxj=%d\n", maxi, maxj);
  return max;
}

double f(r,theta) 
double r,theta;
{
  return r*sin(theta)*cos(theta);
}

double g(r,theta)
double r,theta;
{
  return 0,0;
}

/*
 * msleep.c -- ߥñ̤Υޡ
 */

#include <sys/types.h>
#include <sys/time.h>

int msleep(ms)
int ms;
{
        struct timeval timeout;
        timeout.tv_sec = ms / 1000;
        timeout.tv_usec = (ms % 1000) * 1000;
        if (select(0, (fd_set *) 0, (fd_set *) 0, (fd_set *) 0, &timeout) < 0) {
                perror("usleep");
                return -1;
              }
        return 0;
      }
